// BDE32 3.x - (C) Copyright 1996 by Borland International

#ifndef __QUERY_H
#define __QUERY_H

#include <idapi.h>
#include <windows.h>
#include <stdarg.h>
#include <malloc.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <ctl3d.h>
#include <commdlg.h>
#include <io.h>
#include <direct.h>
#include "macro.h"
#include "query.rh"
#include <windowsx.h>

#define WM_MYSETUP WM_USER + 1
#define MAX_DATABASE_HANDLES    10

// Common dialog defines
#define FILE_OPEN_DIALOG        0
#define FILE_SAVE_DIALOG        1

typedef struct {
                    hDBIDb   hdb;
                    CHAR     szDatabaseName[DBIMAXNAMELEN];
               }DBStruct;

typedef DBStruct DBStructArray[MAX_DATABASE_HANDLES];

extern  HWND hMainWnd;
extern  const pCHAR  szAppName;
extern  const pCHAR  szDialogName;
extern  const pCHAR  szConnectDialogName;
extern  HWND         hMainWnd;
extern  HINSTANCE    hInst;
extern  pCHAR        szMainHelpText;
extern  pCHAR        szConnectHelpText;
extern  WNDPROC      _wpOrigWndProc;
extern  WNDPROC      _wpOrigWndProc1;
extern  INT32        MaxRows;
extern  BOOL         SetMaxRows;

// Directory in which the tables exist. Full path name will be generated
//   by the application
extern CHAR szTblDirectory[];
extern CHAR szPrivDirectory[];

//
// Function prototypes for DISPLAY.C
//
DBIResult     DisplayTable(hDBICur hCur, UINT32 uDisplayNRecs);
void          Screen(pCHAR pszMsg);
void          Cls (void);
void          DisplayProgress(pCHAR szProgress);

//
// Function prototypes for QUERY.C
//

UINT16  SaveQuery(DBIQryLang QryType);
UINT16  LoadQuery(DBIQryLang QryType);
UINT16  SaveResultSet(hDBICur hCur, hDBIDb hDb);
BOOL    InitApp (int nCmdShow);
BOOL    FAR PASCAL _export ConnectDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL    FAR PASCAL HourGlassCursor(BOOL turnOn);
CBRType DBIFN _export GenProgCallBack(CBType ecbType, UINT32 iClientData, pVOID pCbInfo);
UINT16  RemoveConnection(HWND hDlg, DBStructArray array, int nIndex);
LRESULT FAR PASCAL _export MainWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
BOOL    FAR PASCAL _export AboutDlgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
LRESULT FAR PASCAL _export EditSubClassProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
int MakeFullPath(pCHAR pszDirectory, pCHAR pszRelativeDirectory);

//
// Function prototypes for ENGINE.C
//
DBIResult QueryDbiInit(void);
DBIResult QueryDbiExit(void);
void      QueryDbiCloseDatabase(phDBIDb phDb);
hDBIDb    QueryConnectToDatabase(HWND hWnd);
hDBIDb    QueryGetStandardConnection(void);
void      QueryResetConnectDialog(HWND hWnd, const DBStructArray dbarray,
                                     const int iSelected);
DBIResult QueryQExec(hDBIDb hDb, DBIQryLang eQryLang,
                     pCHAR szQuery, pCHAR szOutputErrorString, phDBICur phCur);
BOOL      QuerySaveResultSet(hDBICur hCur, hDBIDb hDb, pCHAR szFileName);
DBIResult GetWorkingDirectory(hDBIDb hDb, pCHAR szDirctory);
DBIResult SetWorkingDirectory(hDBIDb hDb, pCHAR szDirctory);
DBIResult RegisterCallBack(hDBICur hCur, CBType ecbType, UINT32 iClientData,
                           UINT16 iCbBufLen, pVOID pCbBuf, pfDBICallBack pfCb);
void      GetErrorInformation(pCHAR szOutputErrorString);
DBIResult CleanUpAnswer(phDBICur hCur);
BOOL      IsStandardDatabase(hDBIDb);

// Macro for Subclassing the edit control.
#define SubClassWindow(hWnd, lpfn) \
        ((WNDPROC)SetWindowLong((hWnd), GWL_WNDPROC, \
        (LPARAM)(WNDPROC)(lpfn)))

#endif
